# 1.0.1 And later

Changelog for these releases can be found on the releases page, see https://github.com/JouwWeb/SlmQueue/releases.

# 1.0.0

- Identical to 0.8.0 

# 0.8.0

- Adds the ability to add job options to the controller plugin

# 0.7.0

- Adds the ability to store binary data in job content

# 0.6.0

- Provide ServiceManager 3 compatibility
- Provide EventManager 3 compatibility
- [BC] Refactored event flow. Concrete classes are introduced for each event. Listeners should now return a result class when they want to exit the loop or report there internal state. Only an issue if you have your written custom strategies.
- [BC] The EM deprecated the `getEvents` method. No RuntimeException will be thrown when a queue doesn't listen to the Bootstrap event. Probably no one was relying on this, but a potential BC.
- Exiting a worker reported state. The last line now states the reason for exiting.

# 0.5.1

- Improve PHP7 compatibility

# 0.5.0

- [BC] Minimum dependency has been raised to PHP 5.5
- Project has been migrated to PSR-4

# 0.4.2

- Jobs (and execution result) weren't removed from the (reused) WorkerEvent until a new job was processed. These
 'lingering' jobs are now cleared whenever 'pop' is called on the queue by the ProcessQueueStrategy. 

# 0.4.1

- Add a new `MaxPollingFrequencyStrategy` that allows you to limit the rate at which messages are polled.

# 0.4.0

- First stable release of SlmQueue 0.4.0

# 0.4.0-beta3

- BC: to avoid name clashes, the internal `id` and `name` metadata have been renamed `__id__` and `__name__`,
respectively. As a consequence, existing jobs won't be able to be executed correctly. If you need to upgrade to SlmQueue 0.4,
you should create a new queue with the new version (and keeping the old one with old SlmQueue) until all the jobs on the
old system are finished.

# 0.4.0-beta2

- Segregate the `WorkerEvent::PROCESS` event into two different events for more granular control (`WorkerEvent::PROCESS_QUEUE`)
and (`WorkerEvent::PROCESS_JOB`).
- Show more precise memory consumption usage.
- Fix a bug when default queue listener was not attached in some circumstances

# 0.4.0-beta1

- Refactoring of dependency injection to use queue instead of queue name in worker
- Add job status codes so listeners can act on the result of a job's outcome
- Add controller plugin to ease push of jobs into queues
- BC: job's jsonSerialize() removed in favour of the queue's serializeJob() method
- BC: job's metadata field "name" is now reserved for SlmQueue and should not be used by end users

# 0.3.0

- BC: raised dependency to ZF 2.2
- BC: composer package has been changed from "juriansluiman/slm-queue" to "slm/queue". Remember to update
your `composer.json` file!
- BC: AbstractJob constructor is now gone. It simplifies injecting dependencies as you do not need to remember
to call parent constructor.
- BC: keys for configuring queues was previously "queues", it is now "queue_manager". The key "queues" is still used
but it's now for specifying options for a specific queue.
- BC: remove Version class
- BC: ProvidesQueue trait has been renamed to QueueAwareTrait, to provide PSR compliance
- Job metadata is now serialized
- You can make your jobs implement the interface 'SlmQueue\Queue\QueueAwareInterface'. Therefore, you will have
access to the queue in the `execute` method of the job.
- All exceptions now implement `SlmQueue\Exception\ExceptionInterface`, so you can easily filter exceptions.

# 0.2.5

- Change the visibility of the handleSignal function in the worker as it caused a problem
- Fix a bug that may occur on Windows machines

# 0.2.4

- Add support for signals to stop worker properly

# 0.2.3

- Fix compatibilities problems with PHP 5.3

# 0.2.2

- Fix compatibilities problems with PHP 5.3

# 0.2.1

- Fix the default memory limit of the worker (from 1KB, which was obviously wrong, to 100MB)

# 0.2.0

- This version is a complete rewrite of SlmQueue. It is now splitted in several modules and support both
Beanstalkd and Amazon SQS queue systems through SlmQueueBeanstalkd and SlmQueueSqs modules.
